#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define swap(a,b) {tmp = a; a = b; b = tmp;}

typedef unsigned char cbmpByte1;
typedef unsigned int cbmpByte2;
typedef unsigned long cbmpByte4;

typedef struct tag_cbmp {
  cbmpByte4 **image;
  cbmpByte4 width; /* C[W̕ */
  cbmpByte4 height; /* C[W̍(ɑ鎞͐̒l̂) */
} type_cbmp;


/* BMPt@Ctype_cbmpɏo */
type_cbmp *to_cbmp(char *bmpfile);

/* t@Cwb_ǂݍ. bfOffBits:擪摜f[^܂ł̃ItZbg */
static int file_header(FILE * fp, long *bfOffBits);

/* wb_(BITMAPCOREHEADER or BITMAPINFOHEADER)ǂݍ */
static int info_header(FILE * fp,
		       long *InfoSize,/* wb_̃TCY */
		       long *width, /* C[W̕ */
		       long *height, /* C[W̍ */
		       short *BitCount, /*F(sNZ̃rbg)*/
		       long *ClrUsed); /* gpF. 0ȂSFgp */

/* gpF̐Ԃ */
static long count_palette(short biBitCount, long biClrUsed);

/* J[e[u쐬BԂl̓pbg */
static int make_palette(FILE * fp,
			long ClrUsed, /* gpF. 0ȂSFgp */
			/* ȉ̔z̒ǵA
			   ̃CfbNXɑΉJ[pbg.
			   2,16,256Frbg}bvɕKv. */
			unsigned char *red,
			unsigned char *green,
			unsigned char *blue,
			/* wb_̃TCY.
			 WindowOS/2BMP̎ނ𒲂ׂ */
			long InfoSize);

/* bmpt@Cimageɏo */
long set_cbmp_mat(cbmpByte4 **image,
		  FILE * bmp,
		  long bfOffBits, /* 擪摜f[^܂ł̃ItZbg */
		  long width,
		  long height,
		  short BitCount, /* F(sNZ̃rbg) */
		  /* ȉ̔z̒ǵA
		     ̃CfbNXɑΉJ[pbg.
		     2,16,256Frbg}bvɕKv. */
		  unsigned char *red,
		  unsigned char *green,
		  unsigned char *blue);

/* cbmp_obj->imagȅ㉺tɂ */
static void turn_over(type_cbmp *cbmp_obj);


/*
  t@Cwb_ (14 Byte)                                     
  bfOffBits : t@C擪摜f[^܂ł̃ItZbg(byte)
*/
int file_header(FILE * fp, long *bfOffBits)
{
  int count = 0; /* oCgǂ񂾂 */
  char s[10];
  
  /* 2byte : BITMAP F "BM" */
  s[0] = fgetc(fp); s[1] = fgetc(fp); s[2] = '\0'; count += 2;
  if (memcmp(s, "BM", 2) != 0) {
    fprintf(stderr, "%s : Not a BITMAP file\n", s);
    exit(1);
  }
  
  /* 4byte : t@CTCY */
  fgetc(fp); fgetc(fp); fgetc(fp); fgetc(fp); count += 4;
  
  /* 2byte : \̈ 0 */
  fgetc(fp); fgetc(fp); count += 2;
  
  /* 2byte : \̈ 0 */
  fgetc(fp); fgetc(fp); count += 2;
  
  /* 4byte : t@C̐擪摜f[^܂ł̈ʒu */
  *bfOffBits = 
    fgetc(fp) + (fgetc(fp)<<8) + (fgetc(fp)<<16) + (fgetc(fp)<<24);
  count += 4;
    
  return count;
}

/*
  wb_ (12 Byte -> OS/2 Bitmap, 40 Byte -> Windows Bitmap) 
  InfoSize : wb_̃TCY(Bitmap̎ނ܂)            
  ClrUsed : i[Ăpbg (gpF)                  
*/
int info_header(FILE * fp,
		long *InfoSize,/* wb_̃TCY */
		long *width, /* C[W̕ */
		long *height, /* C[W̍ */
		short *BitCount, /* F(sNZ̃rbg) */
		long *ClrUsed)
{
  int count = 0; /* oCgǂ񂾂 */
  long compress = 0; /* k`(̃vO͖k݂̂ɑΉ */

  /* 4byte : wb_̃TCY(Bitmap̎ނ܂) */
  *InfoSize = 
    fgetc(fp) + (fgetc(fp)<<8) + (fgetc(fp)<<16) + (fgetc(fp)<<24);
  count += 4;
  
  /*
  ** OS/2 Bitmap
  */
  if (*InfoSize == 12) {
    /* 2byte : 摜f[^̕ */
    *width = fgetc(fp) + (fgetc(fp)<<8); count += 2;
    
    /* 2byte : 摜f[^̍ */
    *height = fgetc(fp) + (fgetc(fp)<<8); count += 2;

    /* 2byte : v[ (1̂) */
    fgetc(fp); fgetc(fp); count += 2;

    /* 2byte : 1f̃rbg (1, 4, 8, 24, 32) */
    *BitCount = fgetc(fp) + (fgetc(fp)<<8); count += 2;
  }
  
  /*
  ** Windows BMP
  */
  else if (*InfoSize == 40) {
    /* 4byte : 摜f[^̕ */
    *width =
      fgetc(fp) + (fgetc(fp)<<8) + (fgetc(fp)<<16) + (fgetc(fp)<<24);
    count += 4;

    /* 4byte : 摜f[^̍*/
    *height =
      fgetc(fp) + (fgetc(fp)<<8) + (fgetc(fp)<<16) + (fgetc(fp)<<24);
    count += 4;
    
    /* 2byte : v[ (1̂) */
    fgetc(fp); fgetc(fp); count += 2;
    
    /* 2byte : 1f̃rbg (1, 4, 8, 24, 32) */
    *BitCount = fgetc(fp) + (fgetc(fp)<<8); count += 2;
    
    /* 4byte : k  0 : k 
                         1 : BI_RLE8 8bit RunLength k 
                         2 : BI_RLE4 4bit RunLength k */
    compress =
      fgetc(fp) + (fgetc(fp)<<8) + (fgetc(fp)<<16) + (fgetc(fp)<<24);
    count += 4;
    
    /* 4byte : 摜f[^̃TCY */
    fgetc(fp); fgetc(fp); fgetc(fp); fgetc(fp); count += 4;
    
    /* 4byte : 𑜓x (Pixel/meter)(1m̉f) */
    fgetc(fp); fgetc(fp); fgetc(fp); fgetc(fp); count += 4;

    /* 4byte : c𑜓x (Pixel/meter) (1m̉f) */
    fgetc(fp); fgetc(fp); fgetc(fp); fgetc(fp); count += 4;
    
    /* 4byte : i[Ăpbg (gpF) (0̏ꍇ) */
    fgetc(fp); fgetc(fp); fgetc(fp); fgetc(fp); count += 4;
    
    /* dvȐF̐ 0̏ꍇׂĂ̐F */
    fgetc(fp); fgetc(fp); fgetc(fp); fgetc(fp); count += 4;
  }

  /*
  ** (OS/2 Bitmap, Windows Bitmap)ȊO
  */
  else {
    fprintf(stderr, "Bitmap Info Header error\n");
    exit(1);
  }

  /* ̃vO͈kɂ͔Ή */
  if (compress != 0) {
    fprintf(stderr, "krbg}bvɂ͑ΉĂ܂\n");
    exit(1);
  }
  
  switch (*BitCount) {
  case 32: case 24: case 8: case 4: case 1:
    break;
  default:
    fprintf(stderr, "%d rbgFɂ͑ΉĂ܂\n", *BitCount);
    exit(1);
    break;
  }
  return count;
}

/*
  gpFJEg
*/
long count_palette(short biBitCount, long biClrUsed)
{
  /* biClrUsed ɎۂɎgpĂJ[e[u */
  if (biClrUsed != 0) {
    return biClrUsed;
  }
  /* biClrUsed0̏ꍇɂ́CbiBitCount Ɠ */
  else {
    return 1 << biBitCount;
  }
}

/*
  J[e[u
*/
int make_palette(FILE * fp,
		 long ClrUsed,
		 unsigned char *red, 
		 unsigned char *green, 
		 unsigned char *blue,
		 long InfoSize)
{
  long i;
  int count = 0;

  /* rbg̕т B G R (\) */
  for (i = 0; i < ClrUsed; i++) {
    blue[i] = fgetc(fp);
    green[i] = fgetc(fp);
    red[i] = fgetc(fp);
    if (InfoSize == 40) /* Windows bitmap ̏ꍇ͗\̈悪 */
      fgetc(fp);
    count++;
  }
  return count;
}

/*
  bmpt@Cimageɏo
*/
long set_cbmp_mat(cbmpByte4 **image,
		  FILE * bmp,
		  long bfOffBits, /*擪摜f[^܂ł̃ItZbg*/
		  long width,
		  long height,
		  short BitCount, /* F(sNZ̃rbg) */
		  /* ȉ̔z̒ǵA
		     ̃CfbNXɑΉJ[pbg.
		     2,16,256Frbg}bvɕKv. */
		  unsigned char *red, 
		  unsigned char *green, 
		  unsigned char *blue)
{
  int r, g, b;
  long i, j, line, position, count = 0;
  unsigned char buf = 0, bufp = 0; /* 4,2bitFp */
  int index; /* 2,4,8bitFɎgJ[e[ũCfbNX */
  
  /* 1s̐4byte Eɂ킹 */
  line = width * BitCount; /* CO1sbitPʂ̐ */
  line = (line % 8) ? line/8 + 1 : line/8;/* CO1sbytePʂ̐ */
  if ((line % 4) != 0) /* 4byteEɍ킹Kv */
    line = ((line / 4) + 1) * 4; /* C1s̃f[^(byteP) */
  
  for (i = 0; i < height; i++) {
    /* bfOffBits : t@C擪摜f[^܂ł̃ItZbg */
    position = bfOffBits + line * (height - (i + 1));/*@ */
    /* t@Cʒuwqt@C̐擪(SEEK_SET)ƂāA
       posistion oCgړ܂ */
    fseek(bmp, position, SEEK_SET);

    bufp = 0; /* O̍s̍ŌɕtĂ]ȃf[^폜 */
    
    for (j = 0; j < width; j++) {
      /* 32 bit F */
      if (BitCount == 32) {
        b = fgetc(bmp);
        g = fgetc(bmp);
        r = fgetc(bmp);
        fgetc(bmp); /* Reserved 0ŌŒ */
	image[i][j] = (r << 16) + (g << 8) + b;
        count++;
      }
      /* 24 bit F */
      else if (BitCount == 24) {
	b = fgetc(bmp);
	g = fgetc(bmp);
	r = fgetc(bmp);
	image[i][j] = (r << 16) + (g << 8) + b;
	count++;
      }
      /* 8 bit F */
      else if (BitCount == 8) {
        index = fgetc(bmp);
        image[i][j] =
	  (red[index]<<16) + (green[index]<<8) + blue[index];
        count++;
      }
      /* 1,4 bit F */
      else if (BitCount == 4 || BitCount == 1) {
	if (bufp == 0){
	  bufp = 8;
	  buf = fgetc(bmp);
	}
	bufp -= BitCount;
	index = (BitCount == 4) ? (buf >> bufp) & 0xf : (buf >> bufp) & 1;
	image[i][j] =
	  (red[index]<<16) + (green[index]<<8) + blue[index];
      }
    }
  }
  
  return count;
}

/*
  cbmp_obj->imagȅ㉺tɂ.(sign̎Ɏgp)
*/
void turn_over(type_cbmp *cbmp_obj)
{
  int i, j, k;
  cbmpByte4 tmp;
  for(i = 0, j = cbmp_obj->height - 1; 0 < j - i; i++, j--)
    for(k = 0; k < cbmp_obj->width; k++)
      swap(cbmp_obj->image[i][k],
	   cbmp_obj->image[j][k]);
}

/*
  bmpt@Ccbmp֕ϊ     
*/
type_cbmp *to_cbmp(char *bmpfile)
{
  type_cbmp *cbmp_obj;
  long bfOffBits; /* t@C擪摜f[^܂ł̃ItZbg (byte) */
  long InfoSize; /* wb_̃TCY (Bitmap̎ނ܂) */
  long width, height;
  short BitCount; /* F(sNZ̃rbg) */
  long ClrUsed = 0; /* gpF */
  unsigned char red[256], green[256], blue[256]; /* J[e[u */
  FILE *fp;
  int sign;
  cbmpByte2 i;

  if ((fp = fopen(bmpfile, "rb")) == NULL) {
    fprintf(stderr, "In to_cbmp():\nCannot open file : %s\n", bmpfile);
    exit(1);
  }
  /* wb_ : t@Cwb_ */
  file_header(fp, &bfOffBits);
  
  /* wb_ : wb_ */
  info_header(fp, &InfoSize, &width, &height, &BitCount, &ClrUsed);

  /* Ȃ΍E, Ȃ΍ォȄɃf[^L^ */
  sign = (height < 0) ? -1 : 1;
  
  /* ̂̍쐬 */
  /*free(cbmp_obj);*/ /* NULLgĂ͂Ȃ̂ŉ */
  cbmp_obj = malloc(sizeof(type_cbmp));
  cbmp_obj->width = width;
  cbmp_obj->height = abs(height);
  /*free(cbmp_obj->image);*/ /* NULLgĂ͂Ȃ̂ŉ */
  cbmp_obj->image = (cbmpByte4 **)malloc
    ( sizeof(cbmpByte4 *) * cbmp_obj->height );
  for( i = 0; i < cbmp_obj->height; i++)
    cbmp_obj->image[i] = (cbmpByte4 *)malloc
      (sizeof(cbmpByte4) * cbmp_obj->width);
  
  /* BitCount1(2F),4(16F),8(256F)̎̂݊i[ꂽpbgg */
  ClrUsed = count_palette(BitCount, ClrUsed); /* gpFJEg */
  
  /* BitCount1,4,8̎̂݃J[e[ured[],green[],blue[]쐬 */
  if (BitCount == 1 || BitCount == 4 || BitCount == 8)
    make_palette(fp, ClrUsed, red, green, blue, InfoSize);
  
  /* cbmp_mat֏o */
  switch (BitCount) {
  case 32: case 24: case 8: case 4: case 1:
    set_cbmp_mat(cbmp_obj->image, fp,
		 bfOffBits, width, height, BitCount, red, green, blue);
    break;
  default:
    fprintf(stderr, "%d bit Fɂ͑ΉĂ܂\n", BitCount);
    exit(1);
    break;
  }
  
  fclose(fp);

  /* bmpt@C̍AC[W̏㉺𔽓] */
  if (sign < 0) turn_over(cbmp_obj);
  
  return cbmp_obj;
}
